import { world, ItemStack, Items, ItemTypes, MinecraftBlockTypes, Block } from '@minecraft/server';
// Import variables from other javascript file

var allitems = ItemTypes.getAll()
var itmarray = []
var allitmarray = []
var everything = []
var allvanilla = []
var _blkarray = MinecraftBlockTypes.getAllBlockTypes()
var pre_blkarray = []
var blkarray = []
var allblkarray = []
_blkarray.forEach((block) => {
    pre_blkarray.push(block.id)
})
for (const loop of allitems) {
    if (!pre_blkarray.includes(loop.id)) {
        if (loop.id.startsWith('minecraft:') || !loop.id.includes(':')) {
            itmarray.push(loop.id)
            allvanilla.push(loop.id)
        }
        allitmarray.push(loop.id)
    } else {
        if (loop.id.startsWith('minecraft:') || !loop.id.includes(':')) {
            blkarray.push(loop.id)
            allvanilla.push(loop.id)
        }
        allblkarray.push(loop.id)
    }
    everything.push(loop.id)
}

world.events.blockBreak.subscribe((dat) => {
    const _player = dat.player;
    const _prev = dat.brokenBlockPermutation
    const _dim = dat.dimension;
    const _block = dat.block
    var loc = { "x": _block.location.x, "y": _block.location.y + 1, "z": _block.location.z }

    switch (_prev.type.id) {
        case "randblock:randblock_vanilla_items":
            var pre_item = itmarray[Math.ceil(Math.random() * itmarray.length) - 1]
            var __item = new ItemStack(Items.get(pre_item), 1)
            _dim.spawnItem(__item, loc)
            break
        case "randblock:randblock_vanilla":
            var pre_block = blkarray[Math.ceil(Math.random() * blkarray.length) - 1]
            var __block = new ItemStack(Items.get(pre_block), 1)
            _dim.spawnItem(__block, loc)
            break
        case "randblock:randblock_vanilla_all":
            var pre_all = allvanilla[Math.ceil(Math.random() * allvanilla.length) - 1]
            var __all = new ItemStack(Items.get(pre_all), 1)
            _dim.spawnItem(__all, loc)
            break
        case "randblock:randblock_addons_all":
            var pre_ev = everything[Math.ceil(Math.random() * everything.length) - 1]
            var __rand = new ItemStack(Items.get(pre_ev), 1)
            _dim.spawnItem(__rand, loc)
            break
        case "randblock:randblock_addons":
            var pre_allblk = allblkarray[Math.ceil(Math.random() * allblkarray.length) - 1]
            var __rand = new ItemStack(Items.get(pre_allblk), 1)
            _dim.spawnItem(__rand, loc)
            break
        case "randblock:randblock_addons_items":
            var pre_allitm = allitmarray[Math.ceil(Math.random() * allitmarray.length) - 1]
            var __rand = new ItemStack(Items.get(pre_allitm), 1)
            _dim.spawnItem(__rand, loc)
            break
    }
});
